#ifndef __MAINWINDOW_H__
#define __MAINWINDOW_H__ 1

#include <QtCore>
#include <QtGui>

#include <TelepathyQt4/ConnectionManager>
#include <TelepathyQt4/Connection>
#include <TelepathyQt4/Types>
#include <TelepathyQt4/ClientRegistrar>

#include "MyObserver.h"

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow (QWidget *parent = 0);

private slots:
    void log(const QString &strText, int level = 10);
    void setStatus(const QString &strText, int timeout = 2000);

    void onDoBtnClicked ();
    void onActionSelected (int id);

private:
    QCheckBox      *btnDoText;
    QCheckBox      *btnDoStream;

    QButtonGroup   *btnActionGroup;
    QRadioButton   *btnAccept;
    QRadioButton   *btnIgnore;
    QRadioButton   *btnReject;

    MyObserverPtr   observerText;
    MyObserverPtr   observerStream;

    QPlainTextEdit *txtLogs;
    QGridLayout    *grid;

    ClientRegistrarPtr  clientRegistrar;
};

#endif // __MAINWINDOW_H__
