#include "MyObserver.h"
#include <iostream>
using namespace std;

#include <TelepathyQt4/Channel>
#include <TelepathyQt4/Contact>
#include <TelepathyQt4/Account>
#include <TelepathyQt4/Connection>
#include <TelepathyQt4/Channel>
#include <TelepathyQt4/ChannelDispatchOperation>
#include <TelepathyQt4/ChannelRequest>

MyObserver::MyObserver (const ChannelClassList &channelFilter)
: AbstractClientObserver(channelFilter)
, id(1) // Always ignore
{
    cout << "Approver Constructed" << endl;
}//MyObserver::MyObserver

void
MyObserver::setId (int i)
{
    id = i;
}//MyObserver::setId

void
MyObserver::observeChannels(
        const MethodInvocationContextPtr<> & context,
        const AccountPtr                   & account,
        const ConnectionPtr                & connection,
        const QList <ChannelPtr>           & channels,
        const ChannelDispatchOperationPtr  & dispatchOperation,
        const QList <ChannelRequestPtr>    & requestsSatisfied,
        const QVariantMap                  & observerInfo)
{
    bool bOk;
    QString msg;
    emit log ("Observer got something!");

    context->setFinished ();
/*
    switch (id)
    {
    case 1:
        // Always ignore
        context->setFinishedWithError ("", "");
        emit log ("Ignored");
        break;

    case 2:
        // Always accept
        dispatchOperation->handleWith ("");
        context->setFinished ();
        emit log ("Accepted");
        break;

    case 3:
    {
        // Always reject
        ChannelCloser *closer = new ChannelCloser(dispatchOperation, this);
        bOk =
        QObject::connect (
            closer, SIGNAL (log(const QString &, int)),
            this  , SIGNAL (log(const QString &, int)));
        PendingOperation *pendingClaim = dispatchOperation->claim ();
        bOk =
        QObject::connect (
            pendingClaim, SIGNAL (finished (Tp::PendingOperation *)),
            closer      , SLOT   (onClaimed (Tp::PendingOperation *)));
        emit log ("Claimed");
        break;
    }

    default:
        break;
    }
*/
}//MyObserver::addDispatchOperation

ChannelCloser::ChannelCloser (const ChannelDispatchOperationPtr &cdo,
                              QObject *parent)
: QObject(parent)
, dispatchOp(cdo)
{
}//ChannelCloser::ChannelCloser

void
ChannelCloser::onClaimed (Tp::PendingOperation *operation)
{
    do { // Not a loop
        if (operation->isError ())
        {
            emit log ("Failed to complete claim before closing");
            break;
        }

        foreach (ChannelPtr channel, dispatchOp->channels ())
        {
            emit log ("Close requested on channel");
            channel->requestClose ();
        }
    } while (0); // Not a loop

    this->deleteLater ();
}//ChannelCloser::onClaimed
