#ifndef MYOBSERVER_H
#define MYOBSERVER_H

#include <QtCore>
#include <TelepathyQt4/Types>
#include <TelepathyQt4/AbstractClientObserver>
#include <TelepathyQt4/PendingReady>
#include <TelepathyQt4/ChannelDispatchOperation>
using namespace Tp;

class MyObserver : public QObject, public AbstractClientObserver
{
    Q_OBJECT

public:
    MyObserver (const ChannelClassList &channelFilter);
    void setId (int i);

signals:
    void log(const QString &strText, int level = 10);
    void status(const QString &strText, int timeout = 2000);

private slots:

protected:
    void observeChannels(
            const MethodInvocationContextPtr<> & context,
            const AccountPtr                   & account,
            const ConnectionPtr                & connection,
            const QList <ChannelPtr>           & channels,
            const ChannelDispatchOperationPtr  & dispatchOperation,
            const QList <ChannelRequestPtr>    & requestsSatisfied,
            const QVariantMap                  & observerInfo);

private:
    int id;
};
typedef SharedPtr<MyObserver> MyObserverPtr;

class ChannelCloser : public QObject
{
    Q_OBJECT

public:
    ChannelCloser (const ChannelDispatchOperationPtr &cdo, QObject *parent = 0);

signals:
    void log(const QString &strText, int level = 10);

public slots:
    void onClaimed (Tp::PendingOperation *operation);

private:
    ChannelDispatchOperationPtr dispatchOp;
};

#endif // MYOBSERVER_H
